UNIT mTTicketautomat;

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses Dialogs, SysUtils;

type
  TTicketautomat = class

  private //Attribute
    aktuelleAnzahlung : integer;
    gesamteEinnahmen : integer;
    ticketpreis : integer;
    zugangscode : String;

  public //Methoden
    constructor erzeugen (preisVorgabe: integer; codeVorgabe: string); virtual;
    procedure einnahmenAbholen; virtual;
    procedure geldEinwerfen (betrag: integer); virtual;
    procedure geldZurueckgeben; virtual;
    procedure ticketDrucken; virtual;
    function gibAktuelleAnzahlung : integer; virtual;
    function gibTicketPreis : integer; virtual;

   end;

implementation

//+---------------------------------------------------------------------
//|         TTicketautomat: Methodendefinition 
//+---------------------------------------------------------------------

//-------- erzeuge (public) --------------------------------------------
constructor TTicketautomat.erzeugen (preisVorgabe: integer; codeVorgabe: string);
begin
  ticketpreis := preisVorgabe;
  zugangscode := codeVorgabe;
  aktuelleAnzahlung := 0;
  gesamteEinnahmen  := 0;
end;

//-------- einnahmenAbholen (public) ------------------------------------
procedure TTicketautomat.einnahmenAbholen;
begin
  if InputBox('Authentifizierung', 'Zugangscode: ', '') = zugangscode then begin
    showMessage('OK - die Einnahmen von ' + inttostr(gesamteEinnahmen) + ' Cent knnen entnommen werden!');
    gesamteEinnahmen := 0;
  end
  else
    showMessage('Falsche Authentifizierung: Entnahme verweigert!')
end;

//-------- geldEinwerfen (public) --------------------------------------
procedure TTicketautomat.geldEinwerfen (betrag: integer);
begin
  if betrag > 0 then
    aktuelleAnzahlung := aktuelleAnzahlung + betrag
  else
    showMessage('Na - Sie sollten schon einen positiven Betrag einwerfen!');
end;

//-------- geldZurueckgeben (public) -------------------------------------
procedure TTicketautomat.geldZurueckgeben;
begin
  showMessage('Rckgabe:  ' + inttostr(aktuelleAnzahlung) + ' Cent');
  aktuelleAnzahlung := 0;
end;

//-------- ticketDrucken (public) --------------------------------------
procedure TTicketautomat.ticketDrucken;
begin
  if aktuelleAnzahlung >= ticketPreis then begin
    showMessage('HGT-Parkticket   Wert: ' + inttostr(ticketpreis) + ' Cent');
    gesamteEinnahmen := gesamteEinnahmen + ticketpreis;
    aktuelleAnzahlung := aktuelleAnzahlung - ticketpreis;
  end
  else
    showMessage('Sie haben erst ' + inttostr(aktuelleAnzahlung) + ' Cent eingeworfen!');
end;

//-------- gibAktuelleAnzahlung (public) -------------------------------
function TTicketautomat.gibAktuelleAnzahlung : integer;
begin
  result := aktuelleAnzahlung;
end;

//-------- gibTicketPreis (public) -------------------------------------
function TTicketautomat.gibTicketPreis : integer;
begin
  result := ticketpreis;
end;

end.
